/*
 * RTFM_wcet.h
 *
 * Henrik Tder
 * Per Lindgren
 *
 */

#include <stm32f401xe.h>
#include "dwt.h"
#include <stdint.h>


typedef enum
{
    r1,
    r2,
    j1,
    j2,
    j3
} elem;

typedef enum
{
    NOACTION,
    /* Lock */
    L,
    /* Release */
    R,
    /* Start */
    S,
    /* End */
    E
} action;

typedef struct
{
    /* The DWT counter value */
    uint32_t time;
    /* Which element has been locked */
    elem elem;
    /* If locked or released */
    action action;

} event;


int event_count = 0;

/* Create array containing structs of type locks */
#define MAX_NUM_LOCKS 10
event eventlist[MAX_NUM_LOCKS];
void __attribute__ ((noinline)) trace_event(action a, elem e) {
	eventlist[event_count].time = DWT->CYCCNT;
	eventlist[event_count].action = a;
	eventlist[event_count].elem = e;
	event_count+=1;
}

#define TRACE_EVENT(A,E)	trace_event(A, E);
#define LOCK(X) 			trace_event(L, X);
#define UNLOCK(X) 			trace_event(R, X);

#define IRQh(J) 			(J##_IRQh)

#define JOB_REQUEST(J)		{ }

#define TASK(J)				void IRQh(J) ()

#define BREAKPOINT

void finish_execution(void) {}
