/*
 * =====================================================================================
 *
 *       Filename:  dwt.c
 *
 *    Description:  For DWT Cycle Counter
 *
 *        Version:  1.0
 *        Created:  12/22/2016 08:46:29 AM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Henrik Tjäder (AfoHT), henrik@tjaders.com
 *   Organization:
 *
 * =====================================================================================
 */


/* Includes */
#include "stm32f4xx.h"
#include <stdint.h>
#include "Trace.h"

/* Private macro */
/* Private variables */



/* Private function prototypes */
void dwt_enable(void);
void dwt_disable(void);
void dwt_reset(void);
uint32_t dwt_value(void);

/* Private functions */

void dwt_enable(void)
{
    /* Enable Trace */
    CoreDebug->DEMCR |= CoreDebug_DEMCR_TRCENA_Msk;
    /* Only needed for M7 */
    /*DWT->LAR = 0xC5ACCE55;*/
    /* Clear DWT cycle counter */
    DWT->CYCCNT = 0;
    /* Enable DWT cycle counter */
    DWT->CTRL |= DWT_CTRL_CYCCNTENA_Msk;

}
void dwt_disable(void)
{
    // Disable DWT cycle counter
    DWT->CTRL |= ~DWT_CTRL_CYCCNTENA_Msk;
}

void dwt_reset(void)
{
    DWT->CYCCNT = 0;                  // clear DWT cycle counter
}

uint32_t dwt_value(void)
{
    return DWT->CYCCNT;
}

void dwt_itm_print(void)
{

    /* Need formatting from int to string */
    uint32_t tmp = dwt_value();
    trace_puts(tmp);

}
